﻿package
{
    import flash.display.*;
    import flash.events.*;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.objects.primitives.*;

    import org.papervision3d.cameras.Camera3D;
    import org.papervision3d.render.BasicRenderEngine;
    import org.papervision3d.scenes.Scene3D;
    import org.papervision3d.view.Viewport3D;
    import org.papervision3d.materials.*;
    import org.papervision3d.materials.special.CompositeMaterial;

    [SWF(backgroundColor=0x000000)]

    public class Main extends Sprite
    {
        private var scene:Scene3D;
        private var viewport:Viewport3D;
        private var camera:Camera3D;
        private var renderer:BasicRenderEngine;
		
		static internal var container:Sprite;
		
		
		static internal var bg:Sphere;
		
		
        public function Main()
        {
            stage.align = StageAlign.TOP_LEFT;
            stage.scaleMode = StageScaleMode.NO_SCALE;
            stage.quality = StageQuality.MEDIUM;
			container = this;
            init3D();
			
        }

        private function init3D():void
        {
            //ビューポート設定
            viewport = new Viewport3D(0,0,true);
            viewport.opaqueBackground = 0x000000;
            addChild(viewport);

            //レンダー設定
            renderer = new BasicRenderEngine();

            //カメラ設定
            camera = new Camera3D();
            camera.z = -300;
            camera.focus = 500;
            camera.zoom = 1;

            //シーン設定
            scene = new Scene3D();


			bg = new Sphere(null, Number.MIN_VALUE);
			scene.addChild(bg);

			
			//ルービックキューブ作成
			RubicCube.make_cube(bg);
			
			renderer.renderScene(scene, camera, viewport);			
			
            addEventListener(Event.ENTER_FRAME, onEnterFrame);
        }
		
		
		private function onEnterFrame(event:Event):void {

			if (CubeUnit.count == 0) {
				CubeUnit.rotate(RubicCube.decide_next_operation());
			}
			
			bg.rotationX += 4;
			bg.rotationY += 3;
			bg.rotationZ += 2;
			
			
			renderer.renderScene(scene, camera, viewport);			
		}

	}

}
		
