﻿package  
{
	import flash.events.MouseEvent;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.materials.shadematerials.FlatShadeMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.objects.primitives.Cube;
	
	public class Sheel extends Cube
	{
		
		internal var color_group:int;

		static internal var angle:Array;

		public function Sheel(x:Number, y:Number, z:Number, mat:FlatShadeMaterial, color:int) 
		{
			super(new MaterialsList( { all : mat } ), x, y, z);
			this.color_group = color;
		}

		static internal function init_interpol():void {

		angle = new Array(6);

		angle[RubicCube.YELLOW] = [0, 0, 3];
		angle[RubicCube.WHITE] = [0, 3, 0];
		angle[RubicCube.RED] = [-3, 0, 0];
		angle[RubicCube.ORANGE] = [3, 0, 0];
		angle[RubicCube.GREEN] = [0, 0, -3];
		angle[RubicCube.BLUE] = [0, -3, 0];

	}	

	
	internal function set_color_group(axis:int):void {

		switch(axis) {
		case RubicCube.YELLOW:
			yellow_case();
			break;
		case RubicCube.WHITE:
			white_case();
			break;
		case RubicCube.RED:
			red_case();
			break;
		case RubicCube.ORANGE:
			orange_case();
			break;
		case RubicCube.GREEN:
			green_case();
			break;
		case RubicCube.BLUE:
			blue_case();
		}
	}

	private function white_case():void {

		switch(this.color_group) {
		case RubicCube.YELLOW:
			this.color_group = RubicCube.RED;
			break;
		case RubicCube.GREEN:
			this.color_group = RubicCube.ORANGE;
			break;
		case RubicCube.RED:
			this.color_group = RubicCube.GREEN;
			break;
		case RubicCube.ORANGE:
			this.color_group = RubicCube.YELLOW;
		}
	}

	private function yellow_case():void {
		switch(this.color_group) {
		case RubicCube.BLUE:
			this.color_group = RubicCube.ORANGE;
			break;
		case RubicCube.WHITE:
			this.color_group = RubicCube.RED;
			break;
		case RubicCube.RED:
			this.color_group = RubicCube.BLUE;
			break;
		case RubicCube.ORANGE:
			this.color_group = RubicCube.WHITE;
		}
	}

	private function orange_case():void {
		switch(this.color_group) {
		case RubicCube.BLUE:
			this.color_group = RubicCube.YELLOW;
			break;
		case RubicCube.WHITE:
			this.color_group = RubicCube.GREEN;
			break;
		case RubicCube.GREEN:
			this.color_group = RubicCube.BLUE;
			break;
		case RubicCube.YELLOW:
			this.color_group = RubicCube.WHITE;
		}
	}

	private function blue_case():void {

		switch(this.color_group) {
		case RubicCube.YELLOW:
			this.color_group = RubicCube.ORANGE;
			break;
		case RubicCube.GREEN:
			this.color_group = RubicCube.RED;
			break;
		case RubicCube.RED:
			this.color_group = RubicCube.YELLOW;
			break;
		case RubicCube.ORANGE:
			this.color_group = RubicCube.GREEN;
		}
		
	}

	private function red_case():void {
		switch(this.color_group) {
		case RubicCube.BLUE:
			this.color_group = RubicCube.GREEN;
			break;
		case RubicCube.WHITE:
			this.color_group = RubicCube.YELLOW;
			break;
		case RubicCube.GREEN:
			this.color_group = RubicCube.WHITE;
			break;
		case RubicCube.YELLOW:
			this.color_group = RubicCube.BLUE;
		}
	}

	private function green_case():void {
		switch(this.color_group) {
		case RubicCube.BLUE:
			this.color_group = RubicCube.RED;
			break;
		case RubicCube.WHITE:
			this.color_group = RubicCube.ORANGE;
			break;
		case RubicCube.RED:
			this.color_group = RubicCube.WHITE;
			break;
		case RubicCube.ORANGE:
			this.color_group = RubicCube.BLUE;
		}
	}	
	
	internal function mulTranslation(dx:Number, dy:Number, dz:Number):void {
		
		x += dx;
		y += dy;
		z += dz;
	}
	
}
}


